/*
 * *****************************************************************
 * *                                                               *
 * *    Copyright Compaq Computer Corporation, 2000                *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Compaq    *
 * *   Computer Corporation.  Possession, use,  duplication  or    *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Compaq Computer    *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * HISTORY
 *
 * $OldLog$
 * Revision 1.1.24.1  1999/11/03  04:56:42  Peter_Portante
 * 	Move to thdbl16
 *
 * Revision 1.1.22.2  1999/05/28  14:40:45  Terry_Cassidy
 * 	Initial CMS version
 * 	New-style copyright removed
 * 	Daughter history merged
 * 	History inverted
 * 	[1999/05/28  14:39:31  Terry_Cassidy]
 *
 * Revision 1.1.13.2  1998/12/01  15:46:46  Al_Simons
 * 	Make know about IA-64
 * 	[1998/11/30  20:39:08  Al_Simons]
 * 
 * Revision 1.1.7.3  1998/08/18  18:36:55  Peter_Portante
 * 	DECthreads BL18 code drop
 * 	[1998/08/14  14:04:34  Peter_Portante]
 *
 * Revision 1.1.7.2  1998/04/28  19:14:21  Mary_Sullivan
 * 	DECthreads Steel BL16 Submit
 * 	[1998/04/24  20:58:22  Mary_Sullivan]
 * 
 * Revision 1.1.5.2  1996/12/03  20:37:52  Peter_Portante
 * 	DECthreads PTC BL2 Submission
 * 	[1996/11/20  20:42:16  Peter_Portante]
 * 
 * Revision 1.1.2.5  1995/12/21  23:44:06  Peter_Portante
 * 	DECthreads Pre-BL10 submit
 * 	[1995/12/06  01:09:24  Peter_Portante]
 * 
 * Revision 1.1.2.4  1995/09/27  17:08:26  Peter_Portante
 * 	DECthreads BL8 Pass 2 Submission
 * 	[1995/09/27  16:57:52  Peter_Portante]
 * 
 * Revision 1.1.2.3  1995/08/23  18:39:39  Jacqueline_Berg
 * 	integrate changes for BL8
 * 	[1995/08/21  19:51:57  Jacqueline_Berg]
 * 
 * Revision 1.1.2.2  1995/06/12  20:39:11  David_Long
 * 	Pt DECthreads functional submit for public TIS and static/inline mutexes.
 * 	[1995/06/12  20:03:23  David_Long]
 * 
 * $EndLog$
 * $EndLog$
 *
 * $OldLog:$
 * 	019	Peter Portante	13 May 1998
 * 		Remove unnecessary include of tis.h.
 * 	018	Mary Sullivan	24 February 1998
 * 		When defining 'cma_' => 'CMA$_' aliases, use uppercase
 * 		to match the entry points created by the VMS linker.
 * 	017	Richard Love	24 September 1996
 * 		Remove Asynchronous I/O interfaces created in previous edit.
 * 	016	Peter Portante	20 September 1996
 * 		Add new obsolete Asynchronous I/O interfaces.
 * 	015	Paul Clark	 4 December 1995
 * 		The pointer size adjustments did not properly bracket
 * 		all prototypes that should be handled in 32-bit fashion.
 * 		This resulted in a conflict with DECC's errno.h, for
 * 		anyone compiling with /pointer_size=long.  Add conditionals
 * 		as needed to obtain a successful compile on a pure V7.0
 * 		build system.
 * 	014	Dave Butenhof	 2 August 1995
 * 		Add extern "C" { } block for C++
 * 	013	Peter Portante	 6 June 1995
 * 		Use #if instead of #ifdef for pointer size check.
 * 	012	Peter Portante	 6 June 1995
 * 		Move contents of cma_tis_obs.h back into cma_tis.h
 * 	011	Jak Berg	 9 May 1995
 * 		Make it a shell that includes the various *_OBS headers.
 * 	010	Brian Keane	19 September 1994
 * 		Remove #error directive
 * 	009	Webb Scales	 7 September 1994
 * 		Integrate 30 August 1994 review comments.
 * 	008	Webb Scales	26 May 1994
 * 		Change key type from int to long (see previous edit).
 * 	007	Webb Scales	15 April 1994
 * 		Change once block fields from int's to longs, so that on
 * 		Alpha the pointer field doesn't overflow.
 * 	006	Dave Butenhof & Webb Scales	14 April 1994
 * 		Fix destructor definition to make it VAX ULTRIX safe.
 * 	005	Webb Scales	22 November 1993
 * 		Added configuration symbols.
 * 	004	Webb Scales	30 June 1992
 * 		Corrected the non-proto branch of the prototype macro
 * 	003	Jerry Feldman	23 June 1992
 * 		Fixed prototype for cma_tis_cond_wait to take cond, mutex
 * 		was cond, cond.
 * 	002	Dave Butenhof	10 June 1992
 * 		Remove direct use of "void *" to allow compilation on VAX
 * 		ULTRIX pcc. Also, remove external header file edit history
 * 		(you're reading it :-) ) to separate file.
 * 	001	Webb Scales	28 May 1992
 * 		Add conditional condition variables.
 * $EndLog$
 */
/*
 * @(#)$RCSfile: cma_tis.h,v $ $Revision: 1.1.9.1 $ (DEC) $Date: 2000/03/28 17:06:31 $
 */

/*
 *  FACILITY:
 *
 *	Thread-Independent Synchronization, a subsidiary of DECthreads
 *
 *  ABSTRACT:
 *
 *	This header defines OBSOLETE interfaces. While programs using these
 *	interfaces will continue to be supported, Digital recommends that you
 *	use the improved interfaces described in <tis.h>.
 *
 *  AUTHORS:
 *
 *	Webb Scales
 *
 *  CREATION DATE:
 *
 *	29 April 1992
 *
 *  MODIFIED BY:
 *
 *	Dave Butenhof
 *	Peter Portante
 *	Webb Scales
 *	Mary Sullivan
 *
 *  LAST MODIFIED:
 *
 *	13 May 1998
 */
#ifndef _CMA_TIS_
#define _CMA_TIS_

/*
 * CMA_TIS configuration symbols
 */
#define _CMA_TIS__OSF	1
#define _CMA_TIS__VMS	2

#ifndef _CMA_TIS_OS_
# if defined (__OSF__) || defined (__osf__)
#  define _CMA_TIS_OS_	_CMA_TIS__OSF
# elif defined (vms) || defined (__vms) || defined (__VMS)
#  define _CMA_TIS_OS_	_CMA_TIS__VMS
# elif defined (_WIN32) || defined (WIN32)
#  define _CMA_TIS_OS_	_CMA_TIS__WIN32
# else
#  error _CMA_TIS_OS_ is undefined
# endif
#endif

#define _CMA_TIS__ALPHA	1
#define _CMA_TIS__VAX	2
#define _CMA_TIS__X86	3
#define _CMA_TIS__IA64  4

#ifndef _CMA_TIS_HARDWARE_
# if defined (__alpha) || defined (__ALPHA)
#  define _CMA_TIS_HARDWARE_ _CMA_TIS__ALPHA
# elif defined (__vax__) || defined (__vax) || defined (__VAX)
#  define _CMA_TIS_HARDWARE_ _CMA_TIS__VAX
# elif defined (_M_IX86)
#  define _CMA_TIS_HARDWARE_ _CMA_TIS__X86
# elif defined (__ia64__)
#  define _CMA_TIS_HARDWARE_ _CMA_TIS__IA64
# else
#  error _CMA_TIS_HARDWARE_ is undefined
# endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * On OpenVMS Alpha, make sure that all the "obsolete" TIS interfaces treat
 * client values as strictly 32-bit addresses for compatibility.  If you need
 * 64 bit pointers, you must upgrade to the "native" TIS interfaces.
 */
#if (_CMA_TIS_OS_ == _CMA_TIS__VMS) && (_CMA_TIS_HARDWARE_ == _CMA_TIS__ALPHA)
# if __INITIAL_POINTER_SIZE == 64
#  pragma __required_pointer_size __save
#  pragma __required_pointer_size __short
# endif
#endif

/*
 * General address type
 */
typedef void	*cma_tis_addr_t;

/*
 * TIS condition variable: the address of an internal condition variable object.
 */
typedef cma_tis_addr_t	cma_tis_cond_t;

/*
 * TIS mutex: the address of an internal mutex object.
 */
typedef cma_tis_addr_t	cma_tis_mutex_t;

#if (_CMA_TIS_OS_ == _CMA_TIS__VMS) && (_CMA_TIS_HARDWARE_ == _CMA_TIS__ALPHA)
# if __INITIAL_POINTER_SIZE == 64
#  pragma __required_pointer_size __restore
# endif
#endif

/*
 * TIS one-time initialization control block and its initialization macro.
 *
 * Declare a one time initialization control block as:
 *
 *      static cma_tis_once_t	block = cma_tis_once_init;
 */
typedef struct cma_tis_once_tag {
    long	field1;
    long	field2;
    long	field3;
    }				cma_tis_once_t;

#define cma_tis_once_init	{0, 0, 0}

/*
 * Per-thread context types
 */
typedef long cma_tis_key_t;
typedef void (*cma_tis_destructor_t) (cma_tis_addr_t value);

/*
 * TIS thread-ID: the address of a internal thread object.
 */
typedef cma_tis_addr_t	cma_tis_thread_t;


#if _CMA_TIS_OS_ == _CMA_TIS__VMS
  /*
   * On VMS, these routines must begin with "CMA$" not "cma_", so use a
   * macro to translate on those platforms.
   */
# define cma_tis_errno_get_addr		CMA$TIS_ERRNO_GET_ADDR
# define cma_tis_errno_set_value	CMA$TIS_ERRNO_SET_VALUE
# define cma_tis_vmserrno_get_addr	CMA$TIS_VMSERRNO_GET_ADDR
# define cma_tis_vmserrno_set_value	CMA$TIS_VMSERRNO_SET_VALUE
# define cma_tis_cond_create		CMA$TIS_COND_CREATE
# define cma_tis_cond_delete		CMA$TIS_COND_DELETE
# define cma_tis_cond_broadcast		CMA$TIS_COND_BROADCAST
# define cma_tis_cond_signal		CMA$TIS_COND_SIGNAL
# define cma_tis_cond_wait		CMA$TIS_COND_WAIT
# define cma_tis_key_create		CMA$TIS_KEY_CREATE
# define cma_tis_key_get_context	CMA$TIS_KEY_GET_CONTEXT
# define cma_tis_key_set_context	CMA$TIS_KEY_SET_CONTEXT
# define cma_tis_lock_global		CMA$TIS_LOCK_GLOBAL
# define cma_tis_mutex_create		CMA$TIS_MUTEX_CREATE
# define cma_tis_mutex_delete		CMA$TIS_MUTEX_DELETE
# define cma_tis_mutex_lock		CMA$TIS_MUTEX_LOCK
# define cma_tis_mutex_trylock		CMA$TIS_MUTEX_TRYLOCK
# define cma_tis_mutex_unlock		CMA$TIS_MUTEX_UNLOCK
# define cma_tis_once			CMA$TIS_ONCE
# define cma_tis_thread_get_self	CMA$TIS_THREAD_GET_SELF
# define cma_tis_unlock_global		CMA$TIS_UNLOCK_GLOBAL
#endif

/*
 * TIS functions.
 */

#if (_CMA_TIS_OS_ == _CMA_TIS__VMS) && (_CMA_TIS_HARDWARE_ == _CMA_TIS__ALPHA)
# if __INITIAL_POINTER_SIZE == 64
#  pragma __required_pointer_size __save
#  pragma __required_pointer_size __short
# endif
#endif

/*
 * Get the address of errno
 */
extern int *
cma_tis_errno_get_addr (void);

/*
 * Set all known errno cells to a particular value
 */
extern void
cma_tis_errno_set_value (
	int value);

#if _CMA_TIS_OS_ == _CMA_TIS__VMS
/*
 * Get the address of the VMS-specific errno
 */
extern int *
cma_tis_vmserrno_get_addr (void);

/*
 * Set all known VMS-specific errno cells to a particular value
 */
extern void
cma_tis_vmserrno_set_value (
	int value);

#endif

/*
 * Create a TIS condition variable.
 *
 * "cond" is a pointer to an abstract condition variable, passed by reference,
 * which receives the address of the new condition variable object.
 */
extern int
cma_tis_cond_create (
	cma_tis_cond_t *cond);

/*
 * Delete a TIS condition variable
 *
 * "cond" is the address of the abstract condition variable, passed by
 * reference, which is to be deleted.
 */
extern int
cma_tis_cond_delete (
	cma_tis_cond_t *cond);

/*
 * Broadcast on a TIS condition variable
 *
 * "cond" is the address of the abstract condition variable, passed by
 * reference, on which to broadcast.
 */
extern int
cma_tis_cond_broadcast (
	cma_tis_cond_t *cond);

/*
 * Signal a TIS condition variable
 *
 * "cond" is the address of the abstract condition variable, passed by
 * reference, on which to signal.
 */
extern int
cma_tis_cond_signal (
	cma_tis_cond_t *cond);

/*
 * Wait on a TIS condition variable
 *
 * "cond" is the address of the abstract condition variable, passed by
 * reference, on which to wait.  "mutex" is the address of the abstract mutex,
 * passed by reference, which is associated with "cond".
 */
extern int
cma_tis_cond_wait (
	cma_tis_cond_t	*cond,
	cma_tis_mutex_t	*mutex);

/*
 * Lock and unlock the DECthreads global lock (if present).
 */
extern int
cma_tis_lock_global (void);

extern int
cma_tis_unlock_global (void);

/*
 * Create a per-thread context (also known as "thread-specific storage" key).
 *
 * "Key" is the address of a cell which will receive the key value; this
 * value is used in calls to cma_tis_key_set_context() and
 * cma_tis_key_get_context() to get and set the per-thread context associated
 * with this key.  The same key value is used in each thread to access that
 * thread's context.
 * "Destructor" is the address of a routine which is called to destroy
 * (e.g., deallocate) the per-thread context value when the thread terminates.
 */
extern int
cma_tis_key_create (
	cma_tis_key_t		*key,
	cma_tis_destructor_t	destructor);

/*
 * Get the per-thread context value associated with a particular key.
 *
 * "Key" is a key value returned by a call to cma_tis_key_create().
 * "Value" is the address of a cell which will receive the per-thread context
 * value associated with this key.  The value returned is dependent on the
 * value of the key specified, but unaffected by the actions of any other
 * threads.
 */
extern int
cma_tis_key_get_context (
	cma_tis_key_t	key,
	cma_tis_addr_t	*value);

/*
 * Set the per-thread context value associated with a particular key.
 *
 * "Key" is a key value returned by a call to cma_tis_key_create().
 * "Value" is value to be associated with this key.  Once set, this value
 * can be retrieved in this thread using the same key in a call to
 * cma_tis_key_get_context(); however, other threads' use of this key value
 * is unaffected.
 */
extern int
cma_tis_key_set_context (
	cma_tis_key_t	key,
	cma_tis_addr_t	value);

/*
 * Create a TIS mutex
 *
 * "mutex" is a pointer to an abstract mutex, passed by reference, which
 * receives the address of the new mutex object.
 */
extern int
cma_tis_mutex_create (
	cma_tis_mutex_t *mutex);

/*
 * Delete a TIS mutex
 *
 * "mutex" is the address of the abstract mutex, passed by reference, which is
 * to be deleted.
 */
extern int
cma_tis_mutex_delete (
	cma_tis_mutex_t *mutex);

/*
 * Lock a TIS mutex
 *
 * "mutex" is the address of the abstract mutex, passed by reference, which is
 * to be locked.
 */
extern int
cma_tis_mutex_lock (
	cma_tis_mutex_t *mutex);

/*
 * Non-blocking TIS mutex lock
 *
 * "mutex" is the address of the abstract mutex, passed by reference, which is
 * to be locked.
 *
 * The function returns a boolean value indicating if the mutex was
 * successfully locked.
 */
extern int
cma_tis_mutex_trylock (
	cma_tis_mutex_t *mutex);

/*
 * Unlock a TIS mutex
 *
 * "mutex" is the address of the abstract mutex, passed by reference, which is
 * to be unlocked.
 */
extern int
cma_tis_mutex_unlock (
	cma_tis_mutex_t *mutex);

/*
 * Execute a one-time initialization routine.
 *
 * The specified routine is called exactly once during a program's execution,
 * even if multiple threads call cma_tis_once() simultaneously.  This is
 * useful for performing one-time initialization tasks (e.g., for a facility
 * API), such as creating mutexes and per-thread-context keys.
 *
 * "init_block" is the address of a one-time initialization control block.  This
 * should be in static storage and unique to the initialization routine.
 * "init_routine" is the address of the initialization routine to call.
 * "arg" is a user argument which is passed to the initialization routine.
 */
extern int
cma_tis_once (
	cma_tis_once_t	*init_block,
	void		(*init_rtn) (cma_tis_addr_t arg),
	cma_tis_addr_t	init_arg);

/*
 * Get current thread "ID".  (Returns zero if there are no threads.)
 */
extern cma_tis_thread_t
cma_tis_thread_get_self (void);

#if (_CMA_TIS_OS_ == _CMA_TIS__VMS) && (_CMA_TIS_HARDWARE_ == _CMA_TIS__ALPHA)
# if __INITIAL_POINTER_SIZE == 64
#  pragma __required_pointer_size __restore
# endif
#endif

#ifdef __cplusplus
}
#endif

#endif  /* _CMA_TIS_ */

