/*
 * *****************************************************************
 * *                                                               *
 * *    Copyright Compaq Computer Corporation, 2000                *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Compaq    *
 * *   Computer Corporation.  Possession, use,  duplication  or    *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Compaq Computer    *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * HISTORY
 */
/*
 * @(#)$RCSfile: mcicap_config.h,v $ $Revision: 1.1.2.2 $ (DEC) $Date: 1999/08/25 12:43:37 $
 */

#ifndef MCI_H
#define MCI_H

/* MCI configurator
 *	MCI provides access to a configured media changer.
 *
 *	The open/close interface allows clients to mention
 *	the media changer by name only.  An environment variable
 *	may contain a media capiblities entry or name a file which
 *	will contain an entry describing the named media changer.
 *	If the environment variable is not set, /etc/mcicap is
 *	the default "media cap" file.
 *
 *	MCI also allows clients to register new interfaces.
 *	For an explaination of this feature, please see the manual.
*/


#if defined(__cplusplus)
extern "C" {
#endif

extern MC_ERROR_CODE mci_open(const char *name, media_changer_t **mc);
extern MC_ERROR_CODE mci_close(media_changer_t *mc);
extern MC_ERROR_CODE mci_register(const char *if_name,
				const media_changer_t *(newobject)());

#if defined(__cplusplus)
}
#endif

#endif
